////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s             VMM Tutorial             s////
////s                                      s////
////s           gopi@testbench.in          s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////

  program testing_callbacks();
   Driver drvr =  new();

   class Custom_Driver_callbacks_1 extends Driver_callbacks;
   
     virtual task pre_send();
       $display("CB_1:pre_send: Delaying the packet driving by 20 time units. %d",$time);
       #20;
     endtask
  
     virtual task post_send();
      $display("CB_1:post_send: Just a message from  post send callback method \n");
     endtask
 
   endclass 

   class Custom_Driver_callbacks_2 extends Driver_callbacks;
   
     virtual task pre_send();
       $display("CB_2:pre_send: Hai .... this is from Second callback %d",$time);
     endtask
  
 
   endclass 

   Custom_Driver_callbacks_1 CDc_1 = new();
   Custom_Driver_callbacks_2 CDc_2 = new();
  initial
    begin
    drvr.append_callback(CDc_1);
    drvr.append_callback(CDc_2);
    #100 drvr.start_xactor();
    #200 drvr.stop_xactor();
    end
  endprogram


